
class BoundingCircle extends Entity
{
  int lifeTime = 0;
  float radius; 
  boolean isLand;
  Quad2D quadd;
  int id;
  ArrayList neighbourList = new ArrayList();
  
  float weightMin, weightMax;
  
  public BoundingCircle(PVector ipos, float iradius, boolean isLand, int iid)
  {
    id = iid;
    pos = ipos;
    radius = iradius/4;
    quadd = new Quad2D( ipos, radius*2, radius*2);  
  }
  
  public void Draw(PImage img)
  {
    quadd.Draw(img);
  }
  
  public boolean CircleCollision(PVector iPos, float iradius)
  {
    if ((PVector.sub(pos, iPos)).mag() < (iradius + radius))
    {
      return true;
    }
    
    return false;
  }
   
  
}
