import javax.media.opengl.*;
//import com.sun.opengl.util.*;
//import processing.opengl.*;
//
////add gui after i actually make the switch from p3d to OPENGL
String Mode = OPENGL;
String RMode = OPENGL;  // Rendering mode, mean do we use processing function to display or GL context functions
//String RMode = P3D;  // Rendering mode, mean do we use processing function to display or GL context functions
PFont fontA;
boolean bFlush = false;
//
class GUI
{
  Camera3D cameraa;
  World earth;
  Player p1;
  Quad2D ISmiteQ;
  Quad2D IFingGodQ;
  Quad2D IEntangleQ;
  Quad2D ISaucerQ;
  Quad2D IVirusQ;
  Quad2D IActiveQ;
  
  PImage ISmite;
  PImage IFingGod;
  PImage IEntangle;
  PImage ISaucer;
  PImage IVirus; 
  PImage IActive; 
  PImage notReady;
  
GUI(Camera3D icamera, World iearth, Player ip1) 
{ 
  ISmiteQ = new Quad2D(new PVector(), 60, 60);
  IFingGodQ= new Quad2D(new PVector(), 60,60);
  IEntangleQ= new Quad2D(new PVector(), 60, 60);
  ISaucerQ= new Quad2D(new PVector(), 60, 60);
  IVirusQ= new Quad2D(new PVector(), 60, 60);
  IActiveQ= new Quad2D(new PVector(), 90, 90);
  
  ISmite = loadImage("ISmite.bmp");
  IFingGod = loadImage("IFingGod.bmp");
  IEntangle = loadImage("IEntangle.bmp");
  ISaucer = loadImage("ISaucer.bmp");
  IVirus = loadImage("IVirus.bmp");
  IActive = loadImage("pukecircle.png");
  notReady = loadImage("55alphaBlack.png");
  
  cameraa = icamera;
  earth = iearth;
  p1 = ip1;
  if ( RMode == OPENGL )
    Mode = OPENGL;
  size(800, 600, Mode);

  if ( Mode == OPENGL )
  {
    // enable VSync to avoid framerate problems ?
    PGraphicsOpenGL pgl;
    GL gl;
    pgl = (PGraphicsOpenGL)g; //processing graphics object
    gl = pgl.beginGL(); //begin opengl
    gl.setSwapInterval(1); //set vertical sync on, screen refresh is 60 Hz so framerate will be 60
    pgl.endGL(); //end opengl
    
  }
  else
  {
    frameRate(60); // a little more than 60 because 60hz screen and vsync activated ?
  }

  background(100);
  fontA = loadFont("ComicSansMS-48.vlw");
  

}

// ____________________
void Draw(long elapsedTime) 
{
  //print kills next to where Saucers are:
  
  
  
  //background(10);

  // display framerate
  color FillColor = color(100,100,100, 100);
  fill(FillColor);
  textFont(fontA, 24);
  text("fps    "+ (int)frameRate,                  cameraa.pos.x - cameraa.cwidth + 35, cameraa.pos.y - cameraa.cheight + 155);
  
  if (earth.levelUpDisplayTimeCounter > 0)
  {
    earth.levelUpDisplayTimeCounter -= elapsedTime;
    textFont(fontA, 65);
    
    if (earth.levelUpDisplayTimeCounter > (earth.levelUpDisplayTime - earth.levelUpDisplayFadeTime)) //fade in
    {
      float alphaa = ( ((float)earth.levelUpDisplayTime - (float)earth.levelUpDisplayTimeCounter)/ (float)earth.levelUpDisplayFadeTime) *100;
      FillColor = color(100,100,100, alphaa  );
      fill(FillColor);
    }
    else if (earth.levelUpDisplayTimeCounter < earth.levelUpDisplayFadeTime) //fade out
    {
      float alphaa = (1 - (((float)earth.levelUpDisplayFadeTime - (float)earth.levelUpDisplayTimeCounter) / (float)earth.levelUpDisplayFadeTime) )*100;
      FillColor = color(100,100,100, alphaa  );
      fill(FillColor);
    }
    
    text("Wave "+ earth.level,   cameraa.pos.x - 35, cameraa.pos.y);
  }
  
  FillColor = color(100,100,100, 100);
  fill(FillColor);
  
  textFont(fontA, 18);
  for (int i = 0; i < earth.saucers.size(); i++)
  {
    text("Kills " + ((Saucer)earth.saucers.get(i)).kills,  ((Saucer)earth.saucers.get(i)).quadd.center.x - 70,  ((Saucer)earth.saucers.get(i)).quadd.center.y + 80);
  }
  
  textFont(fontA, 24);
  text("1. Smite: \nReq: " + p1.smiteNatureCost +" Nature \nCooldown " + p1.smiteInterval/1000 + " s",  cameraa.pos.x - cameraa.cwidth + 60,  cameraa.pos.y + cameraa.cheight - 75);
  text("2. Virus: \nReq: "+p1.virusNatureCost+" Nature, "+p1.virusRageCost+" Rage\nCooldown " + p1.virusInterval/1000 + " s",  cameraa.pos.x - cameraa.cwidth + 60 + (310*1),  cameraa.pos.y + cameraa.cheight - 75);
  text("3. Entangle: \nReq: "+p1.entNatureCost+" Nature\nCooldown " + p1.entInterval/1000 + " s",  cameraa.pos.x - cameraa.cwidth + 60 + (320*2),  cameraa.pos.y + cameraa.cheight - 75);
  text("4. Saucer: \nReq: "+p1.saucerLuckCost+" Luck, "+p1.saucerEtherCost+" Ether\nCooldown " + p1.saucerInterval/1000 + " s",  cameraa.pos.x - cameraa.cwidth + 60 + (320*3),  cameraa.pos.y + cameraa.cheight - 75);
  text("5. Finger Of God: \nReq: "+ p1.fingRageCost +" Rage, "+p1.fingEtherCost+" Ether\nCooldown " + p1.fingInterval/1000 + " s",  cameraa.pos.x - cameraa.cwidth + 60 + (320*4),  cameraa.pos.y + cameraa.cheight - 75);
  
  textFont(fontA, 35);
  
  text("  Humans Colonies " + (earth.humans.humanList.size()),     cameraa.pos.x - cameraa.cwidth + 15, cameraa.pos.y - cameraa.cheight + 105);
  text("  Nature " + p1.nature, cameraa.pos.x - cameraa.cwidth + 430, cameraa.pos.y - cameraa.cheight + 55);
  text("Rage " + p1.rage,       cameraa.pos.x - cameraa.cwidth + 530 + (90*3), cameraa.pos.y - cameraa.cheight + 55);
  text("Luck " + p1.luck,       cameraa.pos.x - cameraa.cwidth + 530 + (90*6), cameraa.pos.y - cameraa.cheight + 55);
  text("Ether " + p1.ether,     cameraa.pos.x - cameraa.cwidth + 530 + (90*9), cameraa.pos.y - cameraa.cheight + 55);
  
  textFont(fontA, 30);
  if (p1.natureDiff >= 0)
     text("+" + p1.natureDiff,   cameraa.pos.x - cameraa.cwidth + 500, cameraa.pos.y - cameraa.cheight + 105);
  else
     text(p1.natureDiff,   cameraa.pos.x - cameraa.cwidth + 500, cameraa.pos.y - cameraa.cheight + 80);
  
  FillColor = color(20,80,50, 100);
  fill(FillColor);
  textFont(fontA, 35);
   text("Earth Health " + p1.planetHealth,     cameraa.pos.x - cameraa.cwidth + 35, cameraa.pos.y - cameraa.cheight + 55);
  
  ISmiteQ.MoveTo(new PVector(cameraa.pos.x - cameraa.cwidth + 110,  cameraa.pos.y + cameraa.cheight - 140, 0) );
  IVirusQ.MoveTo(new PVector(cameraa.pos.x - cameraa.cwidth + 110 + (310*1),  cameraa.pos.y + cameraa.cheight - 140, 0) );
  IEntangleQ.MoveTo(new PVector(cameraa.pos.x - cameraa.cwidth + 110 + (320*2),  cameraa.pos.y + cameraa.cheight - 140, 0) );
  ISaucerQ.MoveTo(new PVector(cameraa.pos.x - cameraa.cwidth + 110 + (320*3),  cameraa.pos.y + cameraa.cheight - 140, 0) );
  IFingGodQ.MoveTo(new PVector(cameraa.pos.x - cameraa.cwidth + 110 + (320*4),  cameraa.pos.y + cameraa.cheight - 140, 0) );
  
  
  switch(p1.activeA)
  {
    case 1:
    IActiveQ.MoveTo(ISmiteQ.center);
    break;
    case 2:
    IActiveQ.MoveTo(IFingGodQ.center);
    break;
    case 3:
    IActiveQ.MoveTo(IEntangleQ.center);
    break;
    case 4:
    IActiveQ.MoveTo(ISaucerQ.center);
    break;
    case 5:
    IActiveQ.MoveTo(IVirusQ.center);
    break;
  }
  
 
  IActiveQ.Draw(IActive);
  
   if (p1.smiteReady)
  ISmiteQ.Draw(ISmite);
   else
   {
   ISmiteQ.Draw(ISmite);
   ISmiteQ.Draw(notReady);
   }
  if(p1.fingReady)
  IFingGodQ.Draw(IFingGod);
  else
  {
   IFingGodQ.Draw(IFingGod);
   IFingGodQ.Draw(notReady);
  }
  if(p1.entReady)
  IEntangleQ.Draw(IEntangle);
  else
  {
   IEntangleQ.Draw(IEntangle);
   IEntangleQ.Draw(notReady);
  }
  if(p1.saucerReady)
  ISaucerQ.Draw(ISaucer );
  else
  {
   ISaucerQ.Draw(ISaucer );
   ISaucerQ.Draw(notReady);
  }
  if(p1.virusReady)
  IVirusQ.Draw(IVirus);
  else
  {
   IVirusQ.Draw(IVirus);
   IVirusQ.Draw(notReady);
  }
  //text("Instruction Mode (R) = " + RMode, cameraa.pos.x - cameraa.cwidth + 15, cameraa.pos.y - cameraa.cheight + 105);
  //text("force flush (F) ? " + bFlush,     cameraa.pos.x - cameraa.cwidth + 15, cameraa.pos.y - cameraa.cheight + 140);
  
  
}

 void Testdraw()
 {
   color FillColor = color(100,100,100, 100);
  fill(FillColor);
  textFont(fontA, 24);
  text("TESTING IMNPUT", cameraa.pos.x , cameraa.pos.y);
  
 }
// ____________________
//void Update()
//{
//  if (keyPressed)
//  {
//  if ( key == 'f' || key == 'F' )
//    bFlush = !bFlush;
//
//  if ( key == 'r' || key == 'R' )
//  {
//    if ( Mode == OPENGL )
//    {
//	if (RMode == OPENGL )
//	{
//	  RMode = P3D;
//	  println("going to P3D Rmode");
//	}
//	else if ( RMode == P3D )
//	{
//	  RMode = OPENGL;
//	  println("going to OPENGL Rmode");
//	}
//    }
//    else
//	  println("Can't switch to OpenGL instructions in P3D render mode");
//  }
//  }
//}
}
