
class GameOver extends GameState
{
  int liveTime = 3000;
  int inputCounter = 0;
  int inputMinTime = 120;

  PImage backgroundImg = loadImage("gameover.jpg");
  Camera3D cameraa;

  Quad2D backgroundQuad;

  GameOver()
  {
    cameraa = new Camera3D(new PVector(0,0,0) );
    
    backgroundQuad = new Quad2D( cameraa.pos, cameraa.cwidth, cameraa.cwidth);
  }



  int Update(long elapsedTime)
  { 
    liveTime -= elapsedTime;
    if (liveTime <=0)
    {
        if(keyPressed) {
          return 0;
          }
          
          
         if(checkKey("enter") || checkKey("s") || checkKey("space"))
        {
          println("inputtt");
          return 1;
        }

    }
    return -1;
  }

  void Draw(long elapsedTime)
  {    
    //noCursor(); //hides the cursor
    background(0); //background colour

    ortho( - cameraa.cwidth/2, 
    cameraa.cwidth/2, 
    - cameraa.cheight/1.5, 
    cameraa.cheight/1.5, -100, 100);

    camera(cameraa.pos.x, cameraa.pos.y, 10, // eyeX, eyeY, eyeZ
    cameraa.pos.x, cameraa.pos.y, 0.0, // lookX, lookY, lookZ
    0.0, 1.0, 0.0); // upX, upY, upZ

    //draw scene here
    backgroundQuad.Draw(backgroundImg);
    
  }


  void PrintVector(PVector vec)
  {
    System.out.println("vec x y z: " + vec.x + " " + vec.y + " " + vec.z  );
  }




  boolean[] keys = new boolean[526];
  boolean checkKey(String k)
  {
    for(int i = 0; i < keys.length; i++)
      if(KeyEvent.getKeyText(i).toLowerCase().equals(k.toLowerCase())) return keys[i];  
    return false;
  }

  void keyPressed()
  { 
    keys[keyCode] = true;
  }

  void keyReleased()
  { 
    keys[keyCode] = false; 
  }




}
























