import processing.opengl.*;

//3d Friendly Game Engine Thingy.
//System.out.println("1");
//import java.awt.Button;
ArrayList gameState; //an array that will hold gamestates

long elapsedTime; //in miliseconds 
// Get current time
long start = 1;

int currentState = 0;


void setup() {   
 frameRate(60) ;
 //cursor(HAND);
  
  Frame framer;
   gameState = new ArrayList();
   
   gameState.add(new Menu());
   gameState.add(new Play()); //play is a der. of GameState, and represents the actual game
   gameState.add(new GameOver());

   colorMode(RGB,100); //specifying colours is done between 0 and 100.
   rectMode(CENTER);   //mode for drawing rectangles
//   size(1024, 768, P3D); //screen size
 // size(1024, 768, OPENGL);
   noCursor();
   noStroke();
   fill(50);        //fill colour
   
   start =  System.currentTimeMillis();
 } 
 
 void draw() {

   // Get elapsed time in milliseconds
    elapsedTime = System.currentTimeMillis()-start;
    start = System.currentTimeMillis();
    if (elapsedTime == 0)
      elapsedTime = 1;
  // System.out.println("framerate: " + 1000/elapsedTime + "  elapsedTime: " + elapsedTime);
    //System.out.println("elapsedTime " +System.currentTimeMillis());
   
   background(128,128,128); //background colour
  
   int stateChange =  ((GameState)gameState.get(currentState)).Update(elapsedTime);
                      ((GameState)gameState.get(currentState)).Draw(elapsedTime);


   CheckGameStateChange(stateChange); //check to see if the game state should be changed
                          //(ie. pop a state off and put it on top)
   
 }
 
boolean left=false;
boolean right=false;
boolean center=false;

void mousePressed()
{
  ((GameState)gameState.get(currentState)).mousePressed();
}

void mouseReleased()
{
  ((GameState)gameState.get(currentState)).mouseReleased();
} 

 void CheckGameStateChange(int stateChange)
 {
    if (stateChange == 1)
    {
      
      currentState = 1;
    }
    if (stateChange ==2)
    {
      currentState = 2;
    }
    if (stateChange == 0)
    {
      for (int i = gameState.size() - 1; i >= 0; i--)
      {
        gameState.remove(i);
      }
      gameState.add(new Menu());
     gameState.add(new Play()); //play is a der. of GameState, and represents the actual game
     gameState.add(new GameOver());
     currentState = 0;
    }
 }
