
class Saucer
{
  Quad2D quadd;
  
  float attackRadius;
  
  float rangeToThink = 350; //if there are no humans within this range, then mvoe towards the closest human;
  PVector closestHuman = new PVector(50000, 50000,0); //holds the closest human in the case that there are no humans within the "rangetothink", this is also stored as a dir vector
  boolean humanInRange = true;
  
  PVector vel;
  float speed = 0.12;
  int changeDirCounter = 0;
  int changeDirMax = 2500;
  int kills = 0;
  
  Saucer(PVector ipos, float radius)
  {   
    quadd = new Quad2D(ipos, radius*2, radius*2);
    attackRadius = radius * 0.75;
    
    float rotAmount = (int)random(360);
    vel = new PVector(1,0,0);
    vel = RotateVector(new PVector (0,0,0), rotAmount, vel);
    vel.mult(speed*17);
  }
  int counter = 0;
  void Update(long elapsedTime, float worldHeight, ArrayList humanList)
  {
    changeDirCounter += elapsedTime;
    if (changeDirCounter > changeDirMax)
    {
      PVector closestHuman = new PVector(50000, 50000,0); 
     //  humanInRange = false;
      for (int j = 0; j < humanList.size(); j++)
      {
      //  if (!humanInRange)
      //  {

              //if the closest human is closer than the current closest human
               if( ( closestHuman.mag() ) > (PVector.sub(((Human)humanList.get(j)).quadd.center, quadd.center)).mag())
               {
                 //set closest human = to this human
                 closestHuman = PVector.sub(((Human)humanList.get(j)).quadd.center, quadd.center);
               }
       // }
//        if (CircleCollisionNoOverlap( quadd.center, rangeToThink, ((Human)humanList.get(j)).quadd.center, ((Human)humanList.get(j)).radius ))
//        {
//          humanInRange = true;
//        }
      }
       
            
      if ( (int)random(8) >0 )
      {
      changeDirCounter = 0;
      
      float rotAmount = (int)random(360);
      
      vel.x = 1;
      vel.y = 0;
      vel = RotateVector(new PVector (0,0,0), rotAmount, vel);
      vel.mult(speed*elapsedTime);
      }
      else
      {
        changeDirCounter = 0;
        vel.set(closestHuman);
        vel.normalize();
        vel.mult(speed*elapsedTime);
        counter++;
      }
      
    }
    
    if(quadd.center.y > worldHeight/2)
    {
      changeDirCounter = -changeDirMax*2;
      vel.y = -1;
      vel.x = 0;
      vel.mult (speed*2*elapsedTime);
    }
    else if (quadd.center.y < -worldHeight/2)
    {
      changeDirCounter = -changeDirMax*2;
      vel.y = 1;
      vel.x = 0;
      vel.mult (speed*2*elapsedTime);
    }
    
    quadd.Translate(vel);
  }
  
  
    boolean CircleCollisionNoOverlap(PVector aPos, float aRadius, PVector bPos, float bRadius)
  {
    if ((PVector.sub(aPos, bPos)).mag() < (aRadius + bRadius))
      return true;
    else
      return false;
  }
  
  PVector  RotateVector(PVector rotAxis, float rotAmount, PVector rotVec)
  {
    PVector rotateVec = new PVector();
    rotateVec.set(rotVec);
    rotateVec.sub(rotAxis);
    PVector returnVec = new PVector();
    
    returnVec.x = (rotateVec.x *(cos(rotAmount))) - (rotateVec.y *(sin(rotAmount)));
    returnVec.y = (rotateVec.x *(sin(rotAmount))) + (rotateVec.y *(cos(rotAmount)));
    returnVec.add(rotAxis);
    return returnVec;
  }
  
  void Draw(PImage img)
  {
    quadd.Draw(img);

  }
}
